# DifferentialEquations.jl

[![Join the chat at https://julialang.zulipchat.com #sciml-bridged](https://img.shields.io/static/v1?label=Zulip&message=chat&color=9558b2&labelColor=389826)](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
[![Global Docs](https://img.shields.io/badge/docs-SciML-blue.svg)](https://docs.sciml.ai/DiffEqDocs/stable/)

[![codecov](https://codecov.io/gh/SciML/DifferentialEquations.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/SciML/DifferentialEquations.jl)
[![Build Status](https://github.com/SciML/DifferentialEquations.jl/workflows/CI/badge.svg)](https://github.com/SciML/DifferentialEquations.jl/actions?query=workflow%3ACI)

[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor's%20Guide-blueviolet)](https://github.com/SciML/ColPrac)
[![SciML Code Style](https://img.shields.io/static/v1?label=code%20style&message=SciML&color=9558b2&labelColor=389826)](https://github.com/SciML/SciMLStyle)

[![DOI](https://zenodo.org/badge/58516043.svg)](https://zenodo.org/badge/latestdoi/58516043)

This is a suite for numerically solving differential equations written in Julia
and available for use in Julia, Python, and R. The
purpose of this package is to supply efficient Julia implementations of solvers
for various differential equations. Equations within the realm of this package
include:

- Discrete equations (function maps, discrete stochastic (Gillespie/Markov)
  simulations)
- Ordinary differential equations (ODEs)
- Split and Partitioned ODEs (Symplectic integrators, IMEX Methods)
- Stochastic ordinary differential equations (SODEs or SDEs)
- Stochastic differential-algebraic equations (SDAEs)
- Random differential equations (RODEs or RDEs)
- Differential algebraic equations (DAEs)
- Delay differential equations (DDEs)
- Neutral, retarded, and algebraic delay differential equations (NDDEs, RDDEs, and DDAEs)
- Stochastic delay differential equations (SDDEs)
- Experimental support for stochastic neutral, retarded, and algebraic delay differential equations (SNDDEs, SRDDEs, and SDDAEs)
- Mixed discrete and continuous equations (Hybrid Equations, Jump Diffusions)
- (Stochastic) partial differential equations ((S)PDEs) (with both finite
  difference and finite element methods)
  
The well-optimized DifferentialEquations solvers benchmark as some of the fastest
implementations of classic algorithms. It also includes algorithms from recent
research which routinely outperform the "standard" C/Fortran methods, and algorithms
optimized for high-precision and HPC applications. Simultaneously, it wraps
the classic C/Fortran methods, making it easy to switch over to them whenever
necessary. Solving differential equations with different methods from
different languages and packages can be done by changing one line of code,
allowing for easy benchmarking to ensure you are using the fastest method possible.

DifferentialEquations.jl integrates with the Julia package sphere with:

- GPU acceleration through [CUDA.jl](https://cuda.juliagpu.org/stable/) and [DiffEqGPU.jl](https://docs.sciml.ai/DiffEqGPU/dev/)
- Automated sparsity detection with [Symbolics.jl](https://github.com/JuliaSymbolics/Symbolics.jl)
- Automatic Jacobian coloring with [SparseDiffTools.jl](https://docs.sciml.ai/SparseDiffTools/stable/), allowing for fast solutions
  to problems with sparse or structured (Tridiagonal, Banded, BlockBanded, etc.) Jacobians
- Allowing the specification of linear solvers for maximal efficiency with [LinearSolve.jl](https://docs.sciml.ai/LinearSolve/stable/)
- Progress meter integration with the Visual Studio Code IDE for estimated time to solution
- Automatic plotting of time series and phase plots
- Built-in interpolations
- Wraps for common C/Fortran methods like Sundials and Hairer's radau
- Arbitrary precision with BigFloats and Arbfloats
- Arbitrary array types, allowing the definition of differential equations on
  matrices and distributed arrays
- Unit checked arithmetic with Unitful

Additionally, DifferentialEquations.jl comes with built-in analysis features, including:

- [Forward and Adjoint Sensitivity Analysis (Automatic Differentiation)](https://docs.sciml.ai/SciMLSensitivity/stable/) for fast gradient computations
- [Parameter Estimation and Bayesian Analysis](https://docs.sciml.ai/Overview/stable/highlevels/inverse_problems/)
- Neural differential equations with [DiffEqFlux.jl](https://docs.sciml.ai/DiffEqFlux/stable/)
  for efficient scientific machine learning (scientific ML) and scientific AI.
- Automatic distributed, multithreaded, and GPU [Parallel Ensemble Simulations](https://diffeq.sciml.ai/dev/features/ensemble/)
- [Global Sensitivity Analysis](https://docs.sciml.ai/GlobalSensitivity/stable/)
- [Uncertainty Quantification](https://docs.sciml.ai/Overview/stable/highlevels/uncertainty_quantification/)

This gives a powerful mixture of speed and productivity features to help you
solve and analyze your differential equations faster.

For information on using the package,
[see the stable documentation](https://diffeq.sciml.ai/stable/). Use the
[in-development documentation](https://diffeq.sciml.ai/dev/) for the version of
the documentation which contains the unreleased features.

All of the algorithms are thoroughly tested to ensure accuracy via convergence
tests. The algorithms are continuously tested to show correctness.
IJulia tutorial notebooks
[can be found at DiffEqTutorials.jl](https://github.com/SciML/SciMLTutorials.jl).
Benchmarks
[can be found at DiffEqBenchmarks.jl](https://github.com/SciML/SciMLBenchmarks.jl).
If you find any equation where there seems to be an error, please open an issue.

If you have any questions, or just want to chat about solvers/using the package,
please feel free to chat in the [Gitter channel](https://gitter.im/JuliaDiffEq/Lobby?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge).
For bug reports, feature requests, etc., please submit an issue. If you're
interested in contributing, please see the
[Developer Documentation](http://devdocs.sciml.ai/latest/).

## Supporting and Citing

The software in this ecosystem was developed as part of academic research. If you
would like to help support it, please star the repository, as such metrics may
help us secure funding in the future. If you use SciML software as part
of your research, teaching, or other activities, we would be grateful if you
could cite our work.
[Please see our citation page for guidelines](http://sciml.ai/citing.html).

--------------------------------

## Video Tutorial

[![Video Tutorial](https://user-images.githubusercontent.com/1814174/36342812-bdfd0606-13b8-11e8-9eff-ff219de909e5.PNG)](https://youtu.be/KPEqYtEd-zY)

## Video Introduction

[![Video Introduction to DifferentialEquations.jl](https://user-images.githubusercontent.com/1814174/27973992-e236a9a4-6310-11e7-84af-2b66097cecf9.PNG)](https://youtu.be/75SCMIRlNXM)

## Comparison with MATLAB, R, Julia, Python, C, Mathematica, Maple, and Fortran

<a href="http://www.stochasticlifestyle.com/wp-content/uploads/2019/08/de_solver_software_comparsion.pdf"><img src="http://www.stochasticlifestyle.com/wp-content/uploads/2019/08/de_solver_software_comparsion-1.png" alt="Comparison Of Differential Equation Solver Software" align="middle"/></a>

[See the corresponding blog post](http://www.stochasticlifestyle.com/comparison-differential-equation-solver-suites-matlab-r-julia-python-c-fortran/)

## Example Images

<img src="https://raw.githubusercontent.com/SciML/DifferentialEquations.jl/master/assets/DifferentialEquations_Example.png" align="middle"  />

using DifferentialEquations, Test

@time begin
    @testset "DifferentialEquations" begin
        @testset "Re-exports available" begin
            @test true
        end

        @testset "Basic ODE solve" begin
            f(u, p, t) = 1.01 * u
            u0 = 0.5
            tspan = (0.0, 1.0)
            prob = ODEProblem(f, u0, tspan)
            sol = solve(prob, Tsit5(), reltol = 1.0e-8, abstol = 1.0e-8)
            @test sol.retcode == ReturnCode.Success
            @test length(sol.t) > 0
            @test length(sol.u) > 0
            @test sol.u[1] ≈ u0
        end

        @testset "In-place ODE solve" begin
            function lorenz!(du, u, p, t)
                σ, ρ, β = p
                du[1] = σ * (u[2] - u[1])
                du[2] = u[1] * (ρ - u[3]) - u[2]
                du[3] = u[1] * u[2] - β * u[3]
            end
            u0 = [1.0, 0.0, 0.0]
            tspan = (0.0, 1.0)
            p = (10.0, 28.0, 8 / 3)
            prob = ODEProblem(lorenz!, u0, tspan, p)
            sol = solve(prob, Tsit5())
            @test sol.retcode == ReturnCode.Success
            @test sol.u[1] == u0
            @test length(sol.u[end]) == 3
        end

        @testset "Stiff ODE solve" begin
            function rober!(du, u, p, t)
                y₁, y₂, y₃ = u
                k₁, k₂, k₃ = p
                du[1] = -k₁ * y₁ + k₃ * y₂ * y₃
                du[2] = k₁ * y₁ - k₂ * y₂^2 - k₃ * y₂ * y₃
                du[3] = k₂ * y₂^2
            end
            prob = ODEProblem(rober!, [1.0, 0.0, 0.0], (0.0, 1.0e5), (0.04, 3.0e7, 1.0e4))
            sol = solve(prob, Rodas5P())
            @test sol.retcode == ReturnCode.Success
        end

        @testset "Solution interpolation" begin
            f(u, p, t) = 1.01 * u
            prob = ODEProblem(f, 0.5, (0.0, 1.0))
            sol = solve(prob, Tsit5(), dense = true)
            u_interp = sol(0.5)
            @test u_interp isa Number
            @test u_interp > 0.5
        end

        @testset "Callbacks" begin
            function lorenz!(du, u, p, t)
                du[1] = 10.0 * (u[2] - u[1])
                du[2] = u[1] * (28.0 - u[3]) - u[2]
                du[3] = u[1] * u[2] - (8 / 3) * u[3]
            end
            prob = ODEProblem(lorenz!, [1.0, 0.0, 0.0], (0.0, 1.0))

            # ContinuousCallback
            condition(u, t, integrator) = t - 0.5
            affect!(integrator) = nothing
            cb = ContinuousCallback(condition, affect!)
            sol = solve(prob, Tsit5(); callback = cb)
            @test sol.retcode == ReturnCode.Success

            # DiscreteCallback
            dcb = DiscreteCallback((u, t, integrator) -> t >= 0.5, affect!)
            sol2 = solve(prob, Tsit5(); callback = dcb)
            @test sol2.retcode == ReturnCode.Success
        end

        @testset "Remake" begin
            f(u, p, t) = p * u
            prob = ODEProblem(f, 0.5, (0.0, 1.0), 1.01)
            prob2 = remake(prob; u0 = 1.0)
            sol = solve(prob2, Tsit5())
            @test sol.retcode == ReturnCode.Success
            @test sol.u[1] ≈ 1.0
        end

        @testset "saveat" begin
            f(u, p, t) = 1.01 * u
            prob = ODEProblem(f, 0.5, (0.0, 1.0))
            sol = solve(prob, Tsit5(); saveat = 0.1)
            @test sol.retcode == ReturnCode.Success
            @test length(sol.t) == 11
        end
    end
end

#!/usr/bin/env julia

using DifferentialEquations, Test, SafeTestsets
@time begin
    @time @safetestset "Default Discrete Algorithm" begin
        include("default_discrete_alg_test.jl")
    end
    @time @safetestset "Default Steady State Algorithm" begin
        include("default_steady_state_alg_test.jl")
    end
    @time @safetestset "Default SDE Algorithm" begin
        include("default_sde_alg_test.jl")
    end
    @time @safetestset "Default RODE Algorithm" begin
        include("default_rode_alg_test.jl")
    end
    @time @safetestset "Default DDE Algorithm" begin
        include("default_dde_alg_test.jl")
    end
    @time @safetestset "Default DAE Algorithm" begin
        include("default_dae_alg_test.jl")
    end
    @time @safetestset "Default BVP Algorithm" begin
        include("default_bvp_alg_test.jl")
    end
end

using SciMLTesting, DifferentialEquations, JET, Test

const NONMODULE_REEXPORTS = (
    :AbstractAnalyticalProblem,
    :AddVector,
    :AffineOperator,
    :AllObserved,
    :AnalyticalProblem,
    :AutoFiniteDiff,
    :AutoForwardDiff,
    :AutoSparse,
    :AutoTsit5,
    :AutoVern6,
    :AutoVern7,
    :AutoVern8,
    :AutoVern9,
    :BVPFunction,
    :BVProblem,
    :BatchIntegralFunction,
    :BlockDiagonalOperator,
    :CallbackSet,
    :CheckInit,
    :ContinuousCallback,
    :ConvexOptimizationProblem,
    :DAEFunction,
    :DAEProblem,
    :DAESolution,
    :DDEFunction,
    :DDEProblem,
    :DefaultODEAlgorithm,
    :DiagonalOperator,
    :DiscreteCallback,
    :DiscreteFunction,
    :DiscreteProblem,
    :DynamicalBVPFunction,
    :DynamicalDDEFunction,
    :DynamicalDDEProblem,
    :DynamicalODEFunction,
    :DynamicalODEProblem,
    :DynamicalSDEFunction,
    :DynamicalSDEProblem,
    :EigenvalueProblem,
    :EigenvalueSolution,
    :EnsembleContext,
    :EnsembleDistributed,
    :EnsembleProblem,
    :EnsembleSerial,
    :EnsembleSolution,
    :EnsembleSplitThreads,
    :EnsembleSummary,
    :EnsembleTestSolution,
    :EnsembleThreads,
    :FBDF,
    :FunctionOperator,
    :HomotopyNonlinearFunction,
    :HomotopyProblem,
    :IdentityOperator,
    :ImplicitDiscreteFunction,
    :ImplicitDiscreteProblem,
    :IncrementingODEFunction,
    :IncrementingODEProblem,
    :IntegralFunction,
    :IntegralProblem,
    :IntegralSolution,
    :IntervalNonlinearFunction,
    :IntervalNonlinearProblem,
    :InvertibleOperator,
    :LinearAliasSpecifier,
    :LinearProblem,
    :LinearSolution,
    :MatrixOperator,
    :MultiObjectiveOptimizationFunction,
    :NoiseProblem,
    :NonlinearFunction,
    :NonlinearLeastSquaresProblem,
    :NonlinearProblem,
    :NonlinearSolution,
    :NullOperator,
    :ODEAliasSpecifier,
    :ODEFunction,
    :ODEInputFunction,
    :ODEProblem,
    :ODESolution,
    :OptimizationFunction,
    :OptimizationProblem,
    :OptimizationSolution,
    :PDENoTimeSolution,
    :PDEProblem,
    :PDETimeSeriesSolution,
    :RODEFunction,
    :RODEProblem,
    :RODESolution,
    :Rodas5P,
    :Rosenbrock23,
    :SCCNonlinearProblem,
    :SDDEFunction,
    :SDDEProblem,
    :SDEFunction,
    :SDEProblem,
    :SampledIntegralProblem,
    :ScalarOperator,
    :SecondOrderBVProblem,
    :SecondOrderDDEProblem,
    :SecondOrderODEProblem,
    :SplitFunction,
    :SplitODEProblem,
    :SplitSDEFunction,
    :SplitSDEProblem,
    :StaticWOperator,
    :SteadyStateProblem,
    :SteadyStateSolution,
    :TensorProductOperator,
    :TensorSumOperator,
    :TimeDomain,
    :Tsit5,
    :TwoPointBVPFunction,
    :TwoPointBVProblem,
    :TwoPointDynamicalBVPFunction,
    :TwoPointSecondOrderBVProblem,
    :VectorContinuousCallback,
    :Vern6,
    :Vern7,
    :Vern8,
    :Vern9,
    :WOperator,
    :add_saveat!,
    :add_tstop!,
    :addat!,
    :addat_non_user_cache!,
    :addsteps!,
    :auto_dt_reset!,
    :cache_operator,
    :change_t_via_interpolation!,
    :check_error,
    :check_keywords,
    :concretize,
    :deleteat!,
    :deleteat_non_user_cache!,
    :derivative_discontinuity!,
    :discretize,
    :du_cache,
    :first_tstop,
    :full_cache,
    :get_dt,
    :get_du,
    :get_du!,
    :get_proposed_dt,
    :get_rng,
    :get_tmp_cache,
    :has_adjoint,
    :has_concretization,
    :has_exp,
    :has_expmv,
    :has_expmv!,
    :has_ldiv,
    :has_ldiv!,
    :has_mul,
    :has_mul!,
    :has_rng,
    :has_tstop,
    :init,
    :is_discrete_time_domain,
    :iscached,
    :isclock,
    :isconstant,
    :iscontinuous,
    :isconvertible,
    :isdiscrete,
    :isinplace,
    :islinear,
    :issolverstepclock,
    :issquare,
    :kronsum,
    :pop_tstop!,
    :rand_cache,
    :ratenoise_cache,
    :reeval_internals_due_to_modification!,
    :reinit!,
    :remake,
    :resize_non_user_cache!,
    :savevalues!,
    :set_abstol!,
    :set_proposed_dt!,
    :set_reltol!,
    :set_rng!,
    :set_t!,
    :set_u!,
    :solve,
    :solve!,
    :step!,
    :successful_retcode,
    :supports_solve_rng,
    :symbolic_discretize,
    :terminate!,
    :u_cache,
    :u_modified!,
    :update_coefficients,
    :update_coefficients!,
    :user_cache,
    :warn_compat,
)

const INTENTIONAL_REEXPORTS = (
    NONMODULE_REEXPORTS...,
    :Clocks,
    :EigenvalueTarget,
    :EnsembleAnalysis,
    :OrdinaryDiffEq,
    :ReturnCode,
    :SciMLBase,
    :SciMLLogging,
    :SciMLOperators,
)

run_qa(
    DifferentialEquations;
    api_docs_kwargs = (; rendered_ignore = NONMODULE_REEXPORTS),
    jet_kwargs = (; target_defined_modules = true),
    reexports_allow = INTENTIONAL_REEXPORTS,
)

using DifferentialEquations, Test

function f(du, u, p, t)
    (x, v) = u
    du[1] = v
    du[2] = -x
end

function bc!(resid, sol, p, t)
    resid[1] = sol[1][1]
    resid[2] = sol[end][1] - 1
end

tspan = (0.0, 100.0)
u0 = [0.0, 1.0]
bvp = BVProblem(f, bc!, u0, tspan)
resid_f = Array{Float64}(undef, 2)
sol = solve(bvp, Shooting(Tsit5()))
sol2 = solve(bvp)

@test sol2.alg == Tsit5()
@test all(sol.u .== sol2.u)

function default_algorithm(
        prob::DiffEqBase.AbstractDDEProblem{uType, tType, lType,
            isinplace};
        kwargs...) where {uType, tType, lType, isinplace}
    o = Dict{Symbol, Any}(kwargs)
    extra_kwargs = Any[]
    alg = MethodOfSteps(AutoTsit5(Rosenbrock23(autodiff = false))) # Standard default
    uEltype = eltype(prob.u0)

    alg_hints = get_alg_hints(o)
    tol_level = get_tolerance_level(o)

    if tol_level == :extreme_tol || tol_level == :low_tol
        stiff_alg = Rodas5(autodiff = false)
    else
        stiff_alg = Rosenbrock23(autodiff = false)
    end

    if :stiff ∈ alg_hints
        alg = MethodOfSteps(stiff_alg)
    elseif :nonstiff ∈ alg_hints || length(prob.u0) > 10000
        alg = MethodOfSteps(Tsit5())
    else # :auto
        if tol_level == :extreme_tol || tol_level == :low_tol
            alg = MethodOfSteps(AutoVern7(stiff_alg))
        else
            alg = MethodOfSteps(AutoTsit5(stiff_alg))
        end
    end

    # If adaptivity is not set and the tType is not a float, turn off adaptivity
    # Bad interaction with ForwardDiff
    #!(tType <: AbstractFloat) && (:adaptive ∉ keys(o)) && push!(extra_kwargs,:adaptive=>false)

    alg, extra_kwargs
end

using DifferentialEquations, Test

f = function (du, u, p, t)
    du[1] = 2 - 2u[1]
    du[2] = u[1] - 4u[2]
end
u0 = zeros(2)
prob = SteadyStateProblem(f, u0)

sol = solve(prob)

@test nameof(typeof(sol.alg)) == :GeneralizedFirstOrderAlgorithm

module DifferentialEquations

using Reexport

@reexport using DiffEqBase
@reexport using DiffEqNoiseProcess
@reexport using RecursiveArrayTools

@reexport using SteadyStateDiffEq
@reexport using StochasticDiffEq
@reexport using OrdinaryDiffEq
@reexport using BoundaryValueDiffEq
using Sundials
@reexport using DelayDiffEq

@reexport using DiffEqCallbacks
@reexport using JumpProcesses

using LinearAlgebra

import DiffEqBase: solve
@reexport using LinearSolve
using NonlinearSolve
import SciMLBase

include("default_solve.jl")
include("default_arg_parsing.jl")
include("sde_default_alg.jl")
include("dae_default_alg.jl")
include("dde_default_alg.jl")
include("discrete_default_alg.jl")
include("rode_default_alg.jl")
include("steady_state_default_alg.jl")
include("bvp_default_alg.jl")

end # module

using DifferentialEquations, Test
import SciMLBase

f_additive(u, p, t) = @. p[2] / sqrt(1 + t) - u / (2 * (1 + t))
σ_additive(u, p, t) = @. p[1] * p[2] / sqrt(1 + t)
p = (0.1, 0.05)
additive_analytic(u0, p, t, W) = @. u0 / sqrt(1 + t) + p[2] * (t + p[1] * W) / sqrt(1 + t)
ff_additive = SDEFunction(f_additive, σ_additive, analytic = additive_analytic)
prob_sde_additive = SDEProblem(ff_additive, σ_additive, 1.0, (0.0, 1.0), p)

using Random
Random.seed!(100)

prob = prob_sde_additive
sol = solve(prob, dt = 1 / 2^(3))
@test sol.alg isa SOSRI

sol = solve(prob, dt = 1 / 2^(3), alg_hints = [:additive])
@test sol.alg isa SOSRA

sol = solve(prob, dt = 1 / 2^(3), alg_hints = [:stratonovich])
@test SciMLBase.alg_interpretation(sol.alg) ==
      SciMLBase.AlgorithmInterpretation.Stratonovich
@test sol.alg isa RKMil

f = (du, u, p, t) -> du .= 1.01u
g = function (du, u, p, t)
    du[1, 1] = 0.3u[1]
    du[1, 2] = 0.6u[1]
    du[1, 3] = 0.9u[1]
    du[1, 4] = 0.12u[2]
    du[2, 1] = 1.2u[1]
    du[2, 2] = 0.2u[2]
    du[2, 3] = 0.3u[2]
    du[2, 4] = 1.8u[2]
end
prob = SDEProblem(f, g, ones(2), (0.0, 1.0), noise_rate_prototype = zeros(2, 4))

sol = solve(prob, dt = 1 / 2^(3))
@test sol.alg isa LambaEM

sol = solve(prob, dt = 1 / 2^(3), alg_hints = [:stiff])
@test sol.alg isa ISSEM

sol = solve(prob, dt = 1 / 2^(3), alg_hints = [:additive])
@test sol.alg isa SOSRA

sol = solve(prob, dt = 1 / 2^(3), alg_hints = [:stratonovich])
@test sol.alg isa LambaEulerHeun

function DiffEqBase.__solve(prob::DiffEqBase.DEProblem,
        alg::Union{Nothing, DiffEqBase.DEAlgorithm},
        args...; default_set = false, kwargs...)
    if default_set == true
        error("The chosen algorithm, $alg, does not exist. Please verify that the appropriate solver package has been installed.")
    end
    alg, extra_kwargs = default_algorithm(prob; kwargs...)
    alg = DiffEqBase.prepare_alg(alg, prob.u0, prob.p, prob)

    if alg isa SciMLBase.AbstractNonlinearAlgorithm &&
       prob isa SciMLBase.AbstractSteadyStateProblem
        prob = NonlinearProblem(prob)
    end
    DiffEqBase.solve(prob, alg, args...; default_set = true, kwargs..., extra_kwargs...)
end

function DiffEqBase.__init(prob::DiffEqBase.DEProblem,
        alg::Union{Nothing, DiffEqBase.DEAlgorithm},
        args...; default_set = false, kwargs...)
    if default_set == true
        error("The chosen algorithm, $alg, does not exist. Please verify that the appropriate solver package has been installed.")
    end
    alg, extra_kwargs = default_algorithm(prob; kwargs...)
    alg = DiffEqBase.prepare_alg(alg, prob.u0, prob.p, prob)
    DiffEqBase.init(prob, alg, args...; default_set = true, kwargs..., extra_kwargs...)
end

#=
function DiffEqBase.__solve(prob::JumpProcesses.JumpProblem,alg::Nothing,
               args...;default_set=false,kwargs...)
  if default_set == true
    error("The chosen algorithm, $alg, does not exist. Please verify that the appropriate solver package has been installed.")
  end
  alg,extra_kwargs = default_algorithm(prob.prob;kwargs...)
  DiffEqBase.__solve(prob,alg,args...;default_set=true,kwargs...,extra_kwargs...)
end
=#

export default_algorithm

using DifferentialEquations, Test

f = function (r, yp, y, p, tres)
    r[1] = -0.04 * y[1] + 1.0e4 * y[2] * y[3]
    r[2] = -r[1] - 3.0e7 * y[2] * y[2] - yp[2]
    r[1] -= yp[1]
    r[3] = y[1] + y[2] + y[3] - 1.0
end
u0 = [1.0, 0, 0]
du0 = [-0.04, 0.04, 0.0]
prob_dae_resrob = DAEProblem(f, du0, u0, (0.0, 100000.0))

prob = prob_dae_resrob
sol = solve(prob)

@test sol.alg isa DifferentialEquations.Sundials.IDA

function default_algorithm(prob::DiffEqBase.AbstractSteadyStateProblem; kwargs...)
    o = Dict{Symbol, Any}(kwargs)
    extra_kwargs = Any[]
    alg = NewtonRaphson() # Standard default

    alg_hints = get_alg_hints(o)

    # If adaptivity is not set and the tType is not a float, turn off adaptivity
    # Bad interaction with ForwardDiff
    #!(tType <: AbstractFloat) && (:adaptive ∉ keys(o)) && push!(extra_kwargs,:adaptive=>false)

    alg, extra_kwargs
end

using DifferentialEquations, Test

lags = [0.2]
f = function (u, h, p, t)
    out = -h(p, t - 0.2) + u
end
h = (p, t) -> 0.0

prob = DDEProblem(f, 1.0, h, (0.0, 10.0), constant_lags = lags)

sol = solve(prob)

@test sol.alg isa CompositeAlgorithm
@test sol.alg.algs[1] isa Tsit5
@test sol.alg.algs[2] isa Rosenbrock23

function get_alg_hints(o)
    :alg_hints ∈ keys(o) ? alg_hints = o[:alg_hints] : alg_hints = Symbol[:auto]
end

const LOW_TOL = 1e-6
const MED_TOL = 1e-2
const EXTREME_TOL = 1e-9

function get_tolerance_level(o)
    :reltol ∈ keys(o) ? reltol = o[:reltol] : reltol = 1e-3
    if reltol > MED_TOL
        return :high_tol
    elseif reltol > LOW_TOL
        return :med_tol
    elseif reltol > EXTREME_TOL
        return :low_tol
    else
        return :extreme_tol
    end
end

function callbacks_exists(o)
    :callback ∈ keys(o) ? callback = o[:callback] : callback = nothing
    callback != nothing
end

function mass_matrix_exists(prob)
    prob.f.mass_matrix != I
end

function default_algorithm(
        prob::DiffEqBase.AbstractSDEProblem{uType, tType, isinplace, ND};
        kwargs...) where {uType, tType, isinplace, ND}
    o = Dict{Symbol, Any}(kwargs)
    extra_kwargs = Any[]
    alg = SOSRI() # Standard default
    uEltype = eltype(prob.u0)

    alg_hints = get_alg_hints(o)

    if :commutative ∈ alg_hints
        alg = RKMilCommute()
    end

    is_stiff = :stiff ∈ alg_hints
    is_stratonovich = :stratonovich ∈ alg_hints
    if is_stiff || prob.f.mass_matrix !== I
        alg = ImplicitRKMil(autodiff = false)
    end

    if is_stratonovich
        if is_stiff || prob.f.mass_matrix !== I
            alg = ImplicitRKMil(autodiff = false,
                interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich)
        else
            alg = RKMil(interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich)
        end
    end

    if prob.noise_rate_prototype != nothing || prob.noise != nothing
        if is_stratonovich
            if is_stiff || prob.f.mass_matrix !== I
                alg = ImplicitEulerHeun(autodiff = false)
            else
                alg = LambaEulerHeun()
            end
        else
            if is_stiff || prob.f.mass_matrix !== I
                alg = ISSEM(autodiff = false)
            else
                alg = LambaEM()
            end
        end
    end

    if :additive ∈ alg_hints
        if is_stiff || prob.f.mass_matrix !== I
            alg = SKenCarp(autodiff = false)
        else
            alg = SOSRA()
        end
    end

    # If adaptivity is not set and the tType is not a float, turn off adaptivity
    # Bad interaction with ForwardDiff
    #!(tType <: AbstractFloat) && (:adaptive ∉ keys(o)) && push!(extra_kwargs,:adaptive=>false)

    alg, extra_kwargs
end
